

window.self = window;

require('plugins/dmlib.js');
require('plugins/dreamod.js');
require('plugins/dreamod-adapter.js');

let searchLightReporter;
function reportTrack (name) {
    searchLightReporter?.track(name);
}

const platformId = 2;
window['platformId'] = platformId;

if (window['D']) {
    const searchLight = new window['D']({url: 'https://searchlightgp.dreamo100.com', rootName: 'mining', requestType: 1, distance: 1000});
    const guestId = window['DMLib'] ? window['DMLib'].generateRandomString(16) : "null";
    searchLightReporter = window['SearchLightReporter'] && (new window['SearchLightReporter'](searchLight, guestId, platformId));

    window['SearchLight'] = searchLight;
    window['SearchLight_guestId'] = guestId;
}

reportTrack('before load system js bundle file');
require("src/system.bundle.f45da.js");
reportTrack('after load system js bundle file');

reportTrack('before load map json');
const importMapJson = jsb.fileUtils.getStringFromFile("src/import-map.0cfba.json");
const importMap = JSON.parse(importMapJson);
System.warmup({
    importMap,
    importMapUrl: 'src/import-map.0cfba.json',
    defaultHandler: (urlNoSchema) => {
        require(urlNoSchema.startsWith('/') ? urlNoSchema.substr(1) : urlNoSchema);
    },
});
reportTrack('after load map json');

reportTrack('before load application js');
System.import('./application.33017.js')
.then(({ Application }) => {
    reportTrack('create new application');
    return new Application();
}).then((application) => {
    reportTrack('load cc js');
    return System.import('cc').then((cc) => {
        require('jsb-adapter/engine-adapter.js');
        require('plugins/error-report.js');
        reportTrack('application init');
        return application.init(cc);
    }).then(() => {
        reportTrack('application start');
        return application.start();
    });
}).catch((err) => {
    const errMsg = err.toString() + ', stack: ' + err.stack;
    console.error(errMsg);
    reportTrack('application err, ' + errMsg);
});
